// node modules;
import React, { FC, useState, useEffect } from 'react';
import { CSSTransition } from "react-transition-group";

// local files
import { useStyles } from "./styles";

export const AnimationWrapper: FC<any> = ({ children, delay, ...otherProps }) => {
    const { timeout, className } = otherProps;
    const [showed, setShowed] = useState(false);
    const classes =  useStyles({ theme: { timeout } });

    useEffect(() => {
        if(delay !== undefined) {
            setTimeout(() => {
                setShowed(true)
            }, delay)
        }
    }, []);

    return (
        <CSSTransition
            {...otherProps}
            in={showed}
            unmountOnExit
            classNames={{ ...classes }}
        >
            <div className={className || ''}>
                {children}
            </div>
        </CSSTransition>
    )
}
